
;*** monitor DOS file access
;--- assemble: jwasm -mz filemon.asm

hotkey = 21h       ;F key

F_ACTIVE equ 1

    .286
    .model small
    .386
    option proc:private

    .code

oldint21 dd ?
oldint15 dd ?
hVdd     dw ?
buffer   db 256+8 dup (0)
status   db F_ACTIVE
textc    db ' C / ',00
textnc   db 'NC / ',00
cmdpr    db 'cmdl=>',0
isactive db "FileMon active",13,10,0
isinactive db "FileMon inactive",13,10,0

;--- functions that are monitored
monfunc db 0,3ch,3dh,3eh,41h,43h,4bh,4ch,4eh,56h,57h,5bh,60h,6ch,71h
montext label byte
    db 'Kill Program'    ;00 terminate
    db 'CreateFile  '    ;3c create pathname
    db 'OpenFile    '    ;3d open pathname
    db 'CloseFile   '    ;3e close file handle
    db 'DeleteFile  '    ;41 delete pathname
    db 'FileMode    '    ;43 get/set attributes of pathname
    db 'ExecProg    '    ;4b load and execute program
    db 'Terminate   '    ;4c terminate process with errorcode
    db 'FindFirst   '    ;4e find first file match
    db 'Rename      '    ;56 rename pathname
    db 'Filedate    '    ;57 get/set file handle date/time
    db 'CreatFilShar'    ;5b create file (shared)
    db 'TrueName(60)'    ;60 canonicalize path string
    db 'ExtOpenCreat'    ;6C open file (DOS 4.0)
    db 'LFN-Function'    ;71 long filenames (DOS 7.0)

myint21 proc far

        pushf
        test    byte ptr cs:[status],F_ACTIVE
        jz      sm2
        cmp     ah,00h       ;kill (terminate)
        jz      sm31
        cmp     ah,3Ch       ;create file
        jz      sm3
        cmp     ah,3Dh       ;open file
        jz      sm3
        cmp     ah,3Eh       ;close file
        jz      sm3
        cmp     ah,41h       ;delete file
        jz      sm3
        cmp     ah,43h       ;get/set file attributes
        jz      sm3
        cmp     ah,4Bh       ;execute
        jz      sm32
        cmp     ah,4Ch       ;terminate
        jz      sm31
        cmp     ah,4eh       ;get first file
        jz      sm3
        cmp     ah,56h       ;rename file
        jz      sm3
        cmp     ah,57h       ;get/set file's last written date
        jz      sm3
        cmp     ah,5Bh       ;open file
        jz      sm3
        cmp     ah,60h       ;canonicalize filename
        jz      sm3
        cmp     ah,6Ch       ;open file
        jz      sm3
        cmp     ah,71h       ;LFN
        jz      sm3
sm2:
        popf                 ;zurueckgekehrt wird
        jmp     dword ptr cs:[oldint21]
sm3:
        popf
        push    ax
        push    bx
        push    cx
        push    dx
        push    ds

        pushf
        call    dword ptr cs:[oldint21]

        pushf
        call    fnout
        push    bp
        mov     bp,sp
        push    ax
        mov     ax,[bp+2]         ;flags setzen
        mov     [bp+18],ax
        pop     ax
        pop     bp
        add     sp,12
        iret
sm31:
        push    ax
        push    bx
        push    cx
        push    dx
        push    ds
        pushf
        call    fnout
        add     sp,12
        jmp     sm2
sm32:  ;execute
        push    ax
        push    bx
        push    cx
        push    dx
        push    ds
        pushf
        call    fnout
        call    parmout
        add     sp,12
        jmp     sm3

myint21 endp

fnout proc near

FRAME struct
    org -4
_di     dw ?
_es     dw ?
_bp     dw ?
nflgs   dw ?
nds     dw ?
ndx     dw ?
ncx     dw ?
nbx     dw ?
nax     dw ?
        dw ?
_fl     dw ?
_ds     dw ?
_dx     dw ?
_cx     dw ?
_bx     dw ?
union
_ax     dw ?
struct
_al     db ?
_ah     db ?
ends
ends
_ip     dw ?
_cs     dw ?
FRAME ends

        assume bp:ptr FRAME

        push ax
        push bx
        push cx
        push dx
        push ds
        pushf                   ;werte nach call
        push bp
        mov bp,sp
        push es
        push di

        push cs
        pop ds

        assume  ds:_TEXT

        mov di,offset monfunc
        mov bx,offset montext
        mov cx,sizeof monfunc
        mov al,[bp]._ah   ;function
        .while cx
            .break .if al == [di]
            inc di
            add bx,12
            dec cx
        .endw
        mov cx,12
        mov di,offset buffer+4
        mov dword ptr [di-4]," 12I"
@@:
        mov al,[bx]
        call charout
        inc bx
        loop @B
        mov al,' '
        call charout
                                ;display old AL (=Mode)
        mov al,[bp]._al
        call byteout
        mov al,' '
        call charout

        cmp [bp]._ah,57h
        jz write_bx
        cmp [bp]._ah,3Eh
        jnz @F
write_bx:
        mov ax,[bp]._bx         ;display old BX (=Handle) for 3Eh
        call wordout
@@:
        cmp [bp]._ax,7143h
        jnz @F
        mov ax,[bp]._bx
        call byteout
@@:
        cmp [bp]._ax,7160h
        jnz @F
        mov ax,[bp]._cx
        call byteout
@@:
        cmp [bp]._ax,716Ch
        jnz @F
        mov ax,[bp]._dx
        call byteout
@@:
        mov al,' '
        call charout

        mov ax,[bp].nflgs      ;new flags
        and al,1
        mov bx,offset textc
        jnz @F
        mov bx,offset textnc
@@:
        call strout
                                ;display CS:IP
        mov ax,[bp]._cs
        call wordout
        mov al,':'
        call charout
        mov ax,[bp]._ip
        sub ax,2                ;size "int 21"
        call wordout
        mov al,' '
        call charout
        cmp [bp]._ah,00h
        jz fnout_done
        cmp [bp]._ah,3eh
        jz fnout_done
        cmp [bp]._ah,4Ch
        jz fnout_done
        cmp [bp]._ah,57h
        jz fnout_done
        mov bx,si
        cmp [bp]._ah,47h
        jz disp_fn
        cmp [bp]._ah,60h
        jz disp_fn
        cmp [bp]._ah,6ch
        jz disp_fn
        cmp [bp]._ah,71h
        jnz @F
        cmp [bp]._al,47h
        jz disp_fn
        cmp [bp]._al,4fh  ;LFN get next file?
        jz fnout_done
        cmp [bp]._al,60h
        jz disp_fn
        cmp [bp]._al,6ch
        jz disp_fn
        jnc fnout_done
@@:
        mov bx,[bp]._dx
disp_fn:
        push [bp]._ds
        push bx
        call disp_str
        cmp [bp]._ah,56h
        jz @F
        cmp [bp]._ax,7156h
        jz @F
        test byte ptr [bp].nflgs,1      ;carry?
        jnz fnout_done
        cmp [bp]._ah,60h
        jz @F
        cmp [bp]._ax,7160h
        jnz fnout_done
@@:
        mov al,'>'
        call charout
        push [bp]._es
        push [bp]._di
        call disp_str
fnout_done:
        mov al,13
        call charout
        mov al,10
        call charout
        mov byte ptr [di],0

        mov dx,offset buffer
        mov ax, hVdd
        db 0c4h, 0c4h, 58h, 02h ;call Dispatch routine

        pop di
        pop es
        pop bp
        popf
        pop ds
        pop dx
        pop cx
        pop bx
        pop ax
        ret
        assume bp:nothing
fnout endp

wordout:
        push ax
        mov al,ah
        call byteout
        pop ax
byteout:
        mov ah,al
        shr al,4
        call nibout
        mov al,ah
nibout:
        and al,0Fh
        cmp al,10
        sbb al,69H
        das
charout:
        mov [di],al
        inc di
        ret
strout:
        mov al,[bx]
        call charout
        inc bx
        cmp byte ptr [bx],0
        jnz strout
        ret

;--- display parameter block of int 21h, ah=4B0xh

parmout proc near
        pusha
        push ds
        push es

        push cs
        pop ds

        les si,es:[bx+2]   ;get cmdline of program to start

        mov di, offset buffer
        mov bx, offset cmdpr
        call strout

        mov cl,es:[si]
        inc si
        .while (cl)
            mov al,es:[si]
            inc si
            call charout
            dec cl
        .endw
        mov al,'<'
        call charout
        mov al,13
        call charout
        mov al,10
        call charout
        mov byte ptr [di],0

        mov dx,offset buffer
        mov ax, hVdd
        db 0c4h, 0c4h, 58h, 02h ;call Dispatch routine

        pop es
        pop ds
        popa
        ret
parmout endp

;--- display a far string

disp_str proc
        pop ax
        pop bx
        pop es
        push ax
nextchar:        
        mov al,es:[bx]
        and al,al
        jz done
        push es
        call charout
        pop es
        inc bx
        jmp nextchar
done:
        ret
disp_str endp

myint15  proc  ; watch key presses

        assume ds:nothing

        pushf
        cmp ax,4f00h + hotkey
        jnz ir4
        push ds
        push 0
        pop ds
        assume ds:nothing
        test byte ptr ds:[417h],08     ;alt pressed?
        jz ir41
        xor cs:[status],F_ACTIVE
        push dx
        push cs
        pop ds
        assume  ds:_TEXT
        mov dx, offset isactive
        test cs:[status],F_ACTIVE
        jnz @F
        mov dx, offset isinactive
@@:
        mov ax, hVdd
        db 0c4h, 0c4h, 58h, 02h ;call Dispatch routine
        pop dx
        pop ds
        assume ds:nothing
        popf
        clc
        retf 2  ;this is one of the few occasions where it's ok to replace IRET with RETF 2
ir41:
        pop ds
ir4:
        popf
        jmp     dword ptr cs:[oldint15]

myint15  endp

endres equ $

main    proc c

local psp:word

        mov psp, es

        push cs
        pop es
        push cs
        pop ds
        assume ds:_TEXT
        mov ax,3306h        ;running in NTVDM?
        int 21h
        cmp bx,3205h
        jnz nontvdm

        mov si,offset szVDD         ;DS:SI -> VDD
        mov bx,offset szDispatch    ;??:BX -> "Dispatch"
        mov di,offset szInit        ;??:DI -> "Init"
        db 0c4h, 0c4h, 58h, 0
        jc loadfail
        mov hVdd, ax

        mov es,psp
        mov es,es:[002Ch]
        mov ah,49h
        int 21h

        mov ax,3521h
        int 21h
        mov word ptr oldint21+0,bx
        mov word ptr oldint21+2,es
        mov ax,3515h
        int 21h
        mov word ptr oldint15+0,bx
        mov word ptr oldint15+2,es
        mov dx,offset myint21
        mov ax,2521h
        int 21h
        mov dx,offset myint15
        mov ax,2515h
        int 21h

        mov dx,offset hello
        mov ah,9
        int 21h

        mov dx, offset endres
        add dx, 10Fh
        shr dx, 4
        mov ax,3100h
        int 21h

nontvdm:
        mov ah,9
        mov dx, offset nterr
        int 21h
        mov ax,4c01h
        int 21h
loadfail:
        mov ah,9
        mov dx, offset vdderr
        int 21h
        mov ax,4c01h
        int 21h

main    endp

hello   db 'dos file access monitor tsr',13,10
        db 'switch on/off with alt-f',13,10
        db '$'
nterr   db "must run in NTVDM",13,10,'$'
vdderr  db "FileMonD.dll not found",13,10,'$'

szVDD db "FilemonD.dll",0
szDispatch db "Dispatch",0
szInit db "Init",0

        .stack 1024

        END main
